// definiere Klasse: Car
class Car {
  // Felder
  // Koordinaten
  int x,y;
  // Farbe
  color c;
  
  // Konstruktor mit Übergabewerten für Koordinaten
  public Car (int x, int y) {
    // setze die Koordinaten der Instanz
    this.x = x;
    this.y = y;
    // setze Farbe auf rot
    c = color(255,0,0);
  }
  
  // definiere Methode zum Setzen der Position
  // Parameter: Koordinaten
  void setPos (int x, int y) {
    // setze Koordinaten
    this.x = x;
    this.y = y;
  }
  
  // definiere Methode zum Setzen der Farbe
  // Parameter: Farbe
  void setColor (color c) {
    // setze Farbe
    this.c = c;
  }
  
  // definiere Methode zum zeichnen der Instanz
  void plot () {
    // zeichne unterschiedliche Teile des Autos: Reifen, ...
    // abhängig von dessen Position
    fill(c);
    rect(x-100,y-50,200,100);
    fill(0);
    ellipse(x-75,y+50,20,20);
    ellipse(x+75,y+50,20,20);
    fill(255);
    rect(x+50,y-20,30,40);
    rect(x-10,y-20,20,20);
    rect(x-40,y-20,20,20);
    rect(x-70,y-20,20,20);
  }
}

// deklariere Instanz der Klasse Car
Car s;

void setup () {
  size(800,800);
  // erzeuge neues Objekt der Klasse Car
  s = new Car(400,400);
}

void draw () {
  // fülle Hintergrund
  background(255);
  // setze Position des Autos auf Mausposition
  s.setPos(mouseX,mouseY);
  // zeichne Auto
  s.plot();
}